package com.reyun.bpu.dmp.controller;


import com.reyun.bpu.dmp.utils.CodeEnum;
import com.reyun.bpu.dmp.utils.FileUtil;
import com.reyun.bpu.dmp.utils.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * @program: openapi_v1
 *
 * @description:
 *
 * @author: Leo
 *
 * @create: 2019-06-28 14:28
 **/


@RestController
public class UploadController {

    private Logger logger = LoggerFactory.getLogger(this.getClass());

    @RequestMapping("/helloworld")
    public Result<String> helloworld(String username,String password) {
        System.out.println("username is:"+username);
        System.out.println("username is:"+password);
        // return "Hello SpringBoot!!!"; 使用@RestController注解可以直接这样返回
        return Result.success();
    }

    /**
     * 标准JSON格式
     * @param company 公司名称
     * @param multipartFile 文件流
     * @return
     */
    @RequestMapping(value = "/openapi/supload", method = RequestMethod.POST)
    public Result<String> supload(String company,@RequestParam(value = "filePath") MultipartFile multipartFile){

        try {
            logger.info(company+"====调用自定义接口开始");
            new FileUtil().saveFile(multipartFile);
            logger.info(company+"====调用自定义接口结束");
            return Result.success();
        } catch (Exception e) {
            logger.error(company+"====调用标准接口失败");
            return Result.failed(CodeEnum.FILE_UPLOAD_ERROR);
        }
    }

    /**
     * 用户自定义格式
     * @param company
     * @param multipartFile
     * @return
     */
    @RequestMapping(value = "/openapi/cupload", method = RequestMethod.POST)
    public Result<String> cupload(String company,String fileFormat,@RequestParam(value = "filePath") MultipartFile multipartFile) throws IOException {

        try {
            logger.info(company+"====调用自定义接口开始");
            new FileUtil().saveFile(multipartFile);
            logger.info(company+"====调用自定义接口结束");
            return Result.success();
        } catch (Exception e) {
            logger.error(company+"====调用标准接口失败");
            return Result.failed(CodeEnum.FILE_UPLOAD_ERROR);
        }
    }

    /**
     * 模糊查询
     * @param company
     * @return
     */
    @RequestMapping("/openapi/nameQuery")
    public Result<String> nameQuery(String company) {
        System.out.println("公司名称：" + company);
        List list = new ArrayList<String>();
        String rest = "";
        list.add("北京阿里巴巴有限公司");
        list.add("杭州阿里巴巴有限公司");
        list.add("北京热云科技有限公司");
        Pattern pattern = Pattern.compile(company);
        for (int i = 0; i < list.size(); i++) {
            Matcher matcher = pattern.matcher(list.get(i).toString());
            if (matcher.find()) {
                rest = rest + list.get(i) + ",";
            }
        }
        if (rest.equals("")) {
            return Result.failed(CodeEnum.NOT_EXIST_ERROR);
        }
        else{
            String data = rest.substring(0,rest.length()-1);
            return Result.success(data);

        }

    }






}


