package com.reyun.bpu.dmp.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;


/**
 * @program: openapi_v1
 *
 * @description: json数据解析
 *
 * @author: Leo
 *
 * @create: 2019-07-02 12:00
 **/

public class JsonParse {


    public static void main(String[] args) throws Exception {
        //解析json字符串得到建表字段
        // tableInfo1, tableInfo2, tableInfo3分别为建表语句，表字段（真正的解析逻辑都在tableInfo2），表信息如下:
        String tableInfo1 = "create external table if not exists " + args[0] + "(";
        String tableInfo2 = "";
        String tableInfo3 = ") partitioned by (ds string) row format serde 'org.apache.hadoop.hive.ql.io.orc.OrcSerde' \n" +
                "with serdeproperties ( \n" +
                "  'field.delim'='\\t', \n" +
                "  'serialization.format'='\\t') \n" +
                "stored as inputformat \n" +
                "  'org.apache.hadoop.hive.ql.io.orc.OrcInputFormat' \n" +
                "outputformat\n" +
                "  'org.apache.hadoop.hive.ql.io.orc.OrcOutputFormat'\n";

        String value = "{\n" +
                " \"msgID\":\"1001\",\n" +
                " \"gameVersion\": \"2.0\",\n" +
                " \"OS\": \"android\",\n" +
                " \"accountID\": \"xxx\",\n" +
                " \"level\": 15,\n" +
                " \"gameServer\": \"金戈铁马\",\n" +
                " \"orderID\": \"xxx\",\n" +
                " \"iapID\": \"充值包类型\",\n" +
                " \"currencyAmount\": 99,\n" +
                " \"currencyType\": \"CNY\",\n" +
                " \"virtualCurrencyAmount\": 990,\n" +
                " \"paymentType\": \"支付宝\",\n" +
                " \"status\": \"request\",\n" +
                " \"chargeTime\": 1374732001321,\n" +
                " \"mission\": \"新手任务1\"\n" +
                "}";
        LinkedHashMap<String, String> jsonMap =
                JSON.parseObject(value, new TypeReference<LinkedHashMap<String, String>>() {});
        for (Map.Entry<String, String> entry : jsonMap.entrySet()) {
            System.out.println(entry.getKey() + ":" + entry.getValue());
            String ss = entry.getKey();
            String begaininfo = entry.getValue().substring(0, 1);
            System.out.println(begaininfo);
            if (begaininfo.equals("[")) {
                tableInfo2 = tableInfo2 + ss + " " + "array<string>,";
            }
            else if (begaininfo.equals("{")) {
                tableInfo2 = tableInfo2 + ss + " " + "map<string,string>,";
            }
            else {
                tableInfo2 = tableInfo2 + ss + " " + "string,";
            }
        }

        tableInfo2 = tableInfo2.substring(0,StringUtils.length(tableInfo2) - 1);
        System.out.println("");
        String driverName = "org.apache.hive.jdbc.HiveDriver";
        String sql = tableInfo1 + tableInfo2 + tableInfo3;
        System.out.println(sql);

    }

}
